code            segment
                assume  cs:code,ds:code

		org	100h

reloc		equ	500h
disaved 	equ	offset _disaved+reloc
routine         equ     offset init+reloc
installed       equ     offset _installed+reloc
intnum          equ     offset _intnum+reloc
nointerr        equ     offset _nointerr+reloc

; Salta all'inizio vero e proprio del programma

start:          jmp     start2

copyr:          db      'Mark Memory V 1.01, 8/8/90, by FD_Software.'
                db      10,13,10,'$'

; Inizializzazione del programma
start2:
; Stampa il messaggio iniziale
                lea     dx,[copyr]
                mov     ah,9
		int	21h
; Sposta la parte principale del programma
                mov     di,routine
                lea     si,[init]
                mov     cx,fine-init+1
                rep     movsb
; Manda in esecuzione la parte principale del programma
                jmp     init+reloc


; Parte principale del programma
init:
; Sposta la prima parte del messaggio di copyright
; all'indirizzo cs:005ch
                cld                            ; incremento di DI ed SI
                mov     di,5ch
                lea     si,[copyr]
                mov     cx,18
                rep     movsb
; Sposta i 1024 byte dei vettori di interrupt
; dall'indirizzo 0000:0000 all'indirizzo cs:70h
                xor     si,si                  ; inizio del blocco
                mov     ds,si
                mov     di,70h                 ; destinazione del blocco
                mov     cx,200h                ; lunghezza del blocco / 2
                rep     movsw
; Sposta gli 8 byte dell'area di salvataggio
; per schede EGA posta a 0000:04A8H
		mov	si,04A8H
		mov	cx,4
		rep	movsw
; Sposta i 16 byte dell'area interapps communication
; area posta a 0000:04F0H
		mov	si,04F0H
		mov	cx,8
		rep	movsw
; Salva l'indirizzo della prima locazione di memoria
; che dovra' essere liberata dal DOS all'uscita del
; programma
		mov	cs:word ptr [disaved],di
; Cerca quale dei 7 vettori di interrupt a
; disposizione dell'utente (60h-66h) e' libero
; se sono tutti occupati visualizza un messaggio
; di errore ed esce con ERRORCODE 1
                mov     bx,60h*4
leggi:          mov     ah,35h
                cmp     word ptr [bx],0
                jne     piuquattro
                cmp     word ptr [bx+2],0
                je      cont
piuquattro:     add     bx,4
                cmp     bx,19ch
                je      noint
                jne     leggi
; Salva nel vettore di interrupt trovato il
; segmento del di questo programma
cont:           mov     [bx+2],0ffffh
                mov     ax,cs
                mov     [bx],ax
                push    cs
                pop     ds
; Mette in AL il numero di interrupt utilizzato
                mov     ax,bx
                mov     bl,4
                div     bl
; Lascia in AL solo il digit meno significativo (0-6),
; gli aggiunge il codice ascii dello 0 e salva il valore
; ottenuto nella locazione INTNUM
                and     al,0fh
                add     al,30h
                mov     bx,intnum
                mov     [bx],al
; Stampa quale interrupt e' stato utilizzato
                mov     dx,installed
                mov     ah,9
		int	21h
; Torna al DOS lasciando residente una parte di PSP,
; i 1024 byte dei vettori di interrupt salvati e gli
; altri dati salvati
		mov	dx,ds:word ptr [disaved]
                int     27h
; Stampa un messaggio di errore e torna al DOS con
; ERRORLEVEL 1
noint:          push    cs
                pop     ds
                mov     dx,nointerr
                mov     ah,9
		int	21h
                mov     al,1
                mov     ah,4ch
                int     21h
_installed:     db      'Mark installed on INT 6'
_intnum:        db      '0H.',10,13,'$'
_nointerr:      db      7,'All interrupt (60H-66H) are used.',10,13
                db      'No mark allocated',10,13,'$'
_disaved:	dw	0
fine:
code            ends
                end     start

