code            segment
                assume  cs:code,ds:code

		org	100h

start:
; Salta all'inizio del programma
		jmp	init

; Dati del programma
copyr:		db	'Release Memory V 1.01, 8/8/90, by FD_Software.'
                db      10,13,10,'$'
markid:         db      'Mark Memory V 1.01'
installed:      db      'Release memory installed on INT 6'
intnum:         db      '0H.',10,13
quanti:         db      '0 marks installed, now.',13,10,'$'
nointerr:       db      7,'No mark is placed on interrupt 60H-66H.',10,13
                db      'I can''t disallocate memory.',10,13,'$'
nomcberr:       db      'No MCB present, can''t disallocate memory!'
                db      10,13,'$'
memor:          dw      0

; Inizio del programma vero e proprio
init:
; Stampa messaggio iniziale
                lea     dx,[copyr]
                mov     ah,9
                int     21h
; Cerca il segmento dell'ultimo mark richiamato
; a partire dall'interrupt 66h fino all'interrupt 60h
                xor     ax,ax
                mov     es,ax
                mov     bx,66h*4
leggi:          cmp     es:word ptr [bx+2],0ffffh
                je      cont
menoquattro:    sub     bx,4
                cmp     bx,17ch
                jne     leggi
; Se non e' stato trovato nessun segmento lasciato
; da MARK stampa un messaggio di errore ed esce con
; ERRORLEVEL 1
                push    cs
                pop     ds
                lea     dx,[nointerr]
                mov     ah,9
                int     21h
                mov     ax,4c01h
                int     21h
; Se e' stato trovato un indirizzo di segmento seguito da
; 0FFFFH allora viene controllato se all'offset 5ch di quel
; segmento sia presente la stringa di identificazione di MARK.
; Se non era presente si continua la ricerca con l'interrupt
; precedente
cont:           mov     ax,es:[bx]
                mov     dx,es
                mov     es,ax
                lea     si,[markid]
                mov     di,5ch
                mov     cx,18
                repz    cmpsb
                je      releas
                mov     es,dx
                jmp     menoquattro
; Se era presente la stringa di identificazione di MARK viene
; salvato il segmento in cui risiede MARK
releas:         push    es
; In AL il numero di interrupt utilizzato
                mov     ax,bx
                mov     bl,4
                div     bl
; Lascia in AL solo il digit meno significativo (0-6),
; gli aggiunge il codice ascii dello 0 e salva il valore
; ottenuto nella locazione INTNUM
                and     al,0fh
                add     al,30h
                lea     bx,[intnum]
                mov     [bx],al
; Vengono spostati i 1024 byte dei vettori di interrupt
; precedentemente salvati da MARK
                cld
                cli
; Recupera il segmento di MARK in DS
                pop     ds
		mov	si,70h
		xor	di,di
		mov	es,di
                mov     cx,200h         ; lunghezza del blocco / 2
		rep	movsw
; Ripristina gli 8 byte dell'area di salvataggio
; per schede EGA posta a 0000:04A8H
		mov	di,04A8H
		mov	cx,4
		rep	movsw
; Ripristina i 16 byte dell'area "interapps communication
; area posta a 0000:04F0H"
		mov	di,04F0H
		mov	cx,8
		rep	movsw
		sti
; Mette in ES il segmento del Memory Control
; Block (MCB) di MARK che si trova un paragrafo
; sotto il Program Segment Prefix (PSP) dello
; stesso programma
                mov     ax,ds
                dec     ax
                mov     es,ax
; Ed in DS il segmento di RELEASE
                mov     ax,cs
                mov     ds,ax
; Azzera la lunghezza del blocco allocato per
; che ha il PSP a ES+1:0000
_loop:          mov     es:word ptr [0001],0
; Punta al prossimo MCB
                mov     ax,es
                add     ax,es:word ptr [0003]
                inc     ax
                mov     es,ax
; Controlla che quello puntato sia proprio un MCB
; altrimenti esce con ERRORLEVEL 2
                cmp     es:byte ptr [0000],4dH
                je      simcb
                cmp     es:byte ptr [0000],5ah
                je      simcb
; Stampa un messaggio di errore ed esce con
; ERRORLEVEL 2
                lea     dx,[nomcberr]
                mov     ah,9
                int     21h
                mov     ax,4c02h
                int     21h
; Controlla se i blocchi puntati da DS:100 e da ES:110
; sono uguali, nel qual caso si e' giunti a questo
; programma e quindi sono stati disallocati tutti
; i blocchi di memoria precedenti
simcb:          mov     di,110h
                lea     si,[start]
                mov     cx,21
                rep     cmpsb
                je      esci
                jmp     _loop
; Conta il numero di MARK ancora presenti in memoria
; e lo memorizza in formato di digit ASCII nella
; locazione di memoria [quanti]
; Vengono controllati tutti i vettori di interrupt
; precedenti quello utilizzato con lo stesso metodo
; della routine che cercava l'ultimo MARK allocato
esci:
                lea     bx,[intnum]
                mov     al,[bx]
                xor     ah,ah
                add     al,30h
                mov     bl,4
                mul     bl
                mov     bx,ax
                xor     ax,ax
                mov     es,ax
                jmp     menoquattro2
leggi2:         cmp     es:word ptr [bx+2],0ffffh
                je      cont2
menoquattro2:   sub     bx,4
                cmp     bx,17ch
                jne     leggi2
                jmp     fine
cont2:          mov     ax,es:[bx]
                mov     dx,es
                mov     es,ax
                lea     si,[markid]
                mov     di,5ch
                mov     cx,18
                repz    cmpsb
                mov     es,dx
                je      incrementa
                jmp     menoquattro2
incrementa:     inc     ds:byte ptr [quanti]
                jmp     menoquattro2
; Sposta il segmento dell'INT 22h (indirizzo di
; uscita utilizzato dalla funzione 20h del DOS)
; nel segmento dell'environment chiamante in modo
; che si possa tornare direttamente all'interprete
; dei comandi
fine:           xor     ax,ax
                mov     es,ax
                mov     ax,es:[22h*4+2]
                mov     ds:[16h],ax
; Stampa quale interrupt utilizzato da MARK
; e' stato liberato e quanti MARK sono ancora
; allocati
                lea     dx,[installed]
                mov     ah,9
                int     21h
; Esce dal programma
                int     20h
code            ends
                end     start
